# Artifact Submission

Submitted as part of the paper "Don't Reject This: Key-Recovery Timing Attacks Due to Rejection-Sampling in HQC and BIKE".

The camera-ready version is available [here](./camera-ready-14042022.pdf).

  <details>
  <summary>Abstract and Author information</summary>
Authors:

- Norman Lahr (Fraunhofer SIT) <norman@lahr.email>
- Qian Guo (Lund University) <qian.guo@eit.lth.se>
- Clemens Hlauschek (Technische Universität Wien, RISE GmbH) <clemens.hlauschek@inso.tuwien.ac.at>
- Robin Leander Schröder (Technische Universität Wien) <leander.schroeder@inso.tuwien.ac.at>
- Thomas Johansson (Lund University) <thomas.johansson@eit.lth.se>
- Alexander Nilsson (Lund University, Advenica AB) <alexander.nilsson@eit.lth.se>

Abstract:

  Well before large-scale quantum computers will be available, traditional cryptosystems must be transitioned to post-quantum (PQ) secure schemes. The NIST PQC competition aims to standardize suitable cryptographic schemes. Candidates are evaluated not only on their formal security strengths, but are also judged based on the security with regard to resistance against side-channel attacks. Although round 3 candidates have already been intensively vetted with regard to such attacks, one important attack vector has hitherto been missed: PQ schemes often rely on rejection sampling techniques to obtain pseudorandomness from a specific distribution. In this paper, we reveal that rejection sampling routines that are seeded with secret-dependent information and leak timing information result in practical key recoveryattacks in the code-based key encapsulation mechanisms HQC and BIKE. Both HQC and BIKE have been selected as alternate candidates in the third round of the NIST competition, which puts them on track for getting standardized separately to the finalists. They have already been specifically hardened with constant-time decoders to avoid side-channel attacks. However, in this paper, we show novel timing vulnerabilities in both schemes: (1) Our secret key recovery attack on HQC requires only approx. 866,000 idealized decapsulation timing oracle queries in the 128-bit security setting. It is structurally different from previously identified attacks on the scheme: Previously, exploitable side-channel leakages have been identified in the BCH decoder of a previously submitted HQC version, in the ciphertext check as well as in the pseudorandom function of the Fujisaki-Okamoto transformation. In contrast, our attack uses the fact that the rejection sampling routine invoked during the deterministic re-encryption of the decapsulation leaks secret-dependent timing information, which can be efficiently exploited to recover the secret key when HQC is instantiated with the (now constant-time) BCH decoder, as well as with the RMRS decoder of the current submission. (2) From the timing information of the constant weight word sampler in the BIKE decapsulation, we demonstrate how to distinguish whether the decoding step is successful or not, and how this distinguisher is then used in the framework of the GJS attack to derive the distance spectrum of the secret key, using 5.8 x 10^7 idealized timing oracle queries. We provide details and analyses of the fully implemented attacks, as well as a discussion on possible countermeasures and their limits.
  </details>

# Structure

- [bike-attack](./bike-attack/) is a snapshot of the [open-quantum-safe-attacks](https://github.com/atneit/open-quantum-safe-attacks) repository (commit `13446402c1237d9390d38792669c2ded71ec82e4`).
- [hqc-attack](./hqc-attack/) is a snapshot of the [hqc-attack](https://github.com/hqc-attack/hqc-attack) repository (commit `f38bef192d03f5360b284d56ae12770ba7284435`).
